package sb.wget;


import java.io.File;
import java.util.Properties;
import java.util.ResourceBundle;
import olivamail.core.common.ComUtils;

public class Context {

	public static String homeDir = null;

	public static String tempDir = null;

	public static String outDir = null;

	public static String myName = "SBWGet";

	public static final String myPackagePath = "/sb/wget/";

	private static Properties settings = new Properties();

	public static final int ITERATE_YES = 0;

	public static final int ITERATE_SKIP = 1;

	public static final int ITERATE_OVERWRITE = 2;

	public static String extractorClass = null;

	public static boolean useProxy = false;
	
	public static String proxyHost = null;
	
	public static String proxyPort = null;
	
	public static String proxyUsername = null;
	
	public static String proxyPassword = null;
			
	public static File getSettingsFile() {
		return new File(homeDir + "conf/settings.properties");		
	}
		
	public static void loadSettings() throws Exception {		
		ResourceBundle bundle = null;
		try {
			bundle = ResourceBundle.getBundle("settings",
					java.util.Locale.US);
		} catch (java.util.MissingResourceException mre) {
			mre.printStackTrace();
			return;
		}
		for (java.util.Enumeration e = bundle.getKeys(); e.hasMoreElements();) {
			String key = (String) e.nextElement();
			String value = olivamail.core.common.ComUtils.getStringInternals(bundle
					.getString(key), "utf-8");
			settings.setProperty(key, value);
		}		
		
		useProxy = ComUtils.parseBoolean(Context
				.getProperty("sb.wget.use_proxy"), false);
		if (useProxy) {
			System.out.println("Using proxy...");
			proxyHost = Context.getProperty("sb.wget.proxy_host");
			proxyPort = Context.getProperty("sb.wget.proxy_port");
			proxyUsername = Context.getProperty("sb.wget.proxy_username");
			proxyPassword = Context.getProperty("sb.wget.proxy_password");			
/*
 * System.setProperty("http.proxySet", "true");
 * System.setProperty("http.proxyHost", Context
 * .getProperty("sb.wget.proxy_host")); System.setProperty("http.proxyPort",
 * Context .getProperty("sb.wget.proxy_port"));
 * java.net.Authenticator.setDefault(new java.net.Authenticator() { protected
 * java.net.PasswordAuthentication getPasswordAuthentication() { return new
 * java.net.PasswordAuthentication(Context
 * .getProperty("sb.wget.proxy_username"), Context
 * .getProperty("sb.wget.proxy_password") .toCharArray()); } });
 */			
		}
	}
	
	public static String getProperty(String name) {		
		return settings.getProperty(name);	
	}
	
	public static File getIteratedFile(File target, int iterMode) throws Exception {
		if(target.exists()) {
			if(iterMode == ITERATE_SKIP) {
				System.out.print("File already exists, skipping...");
				return null;
			}
			if(iterMode == ITERATE_OVERWRITE) {
				System.out.print("File already exists, overwriting...");				
				return target;
			}
			String fname = target.getName();
			String ext = "";
			String fileName = fname;
			int dotIdx = fname.lastIndexOf('.');
			if (dotIdx != -1) {
				ext = fname.substring(dotIdx);
				fileName = fname.substring(0, dotIdx);
			}
			int count = 0;
			while (target.exists()) {
				count++;
				String newName = fileName + "-" + String.valueOf(count) + ext;
				target = new File(target.getParent(), newName);
			}						
		}
		return target;
	}	
	
}
