package sb.wget;

import java.io.File;
import java.io.FilenameFilter;
import java.net.URL;


public class WGet {

	public static void main(String[] args) {								
		
		boolean lowVer = false;
		String javaVer = System.getProperty("java.version");
		if(javaVer != null) { 
			int idx0 = javaVer.indexOf('.');
			int idx1 = -1;
			String ver0 = javaVer;
			String ver1 = "-1";
			if (idx0 != -1) {
				ver0 = javaVer.substring(0, idx0);
				idx1 = javaVer.indexOf('.', idx0 + 1);
				if (idx1 != -1)
					ver1 = javaVer.substring(idx0 + 1, idx1);
			}
			int iver0 = -1;
			int iver1 = -1;
			lowVer = true;
			try {
				iver0 = Integer.parseInt(ver0);
				iver1 = Integer.parseInt(ver1);
			} catch (Exception exc) {
				lowVer = false;
				exc.printStackTrace();
			}
			if (lowVer)
				if (iver0 >= 1)
					if (iver1 >= 4)
						lowVer = false;								
		}				
		
		if (lowVer) {
			String verMismatch = Context.myName + ": Java version 1.4 or higher is required. But current is "
					+ System.getProperty("java.version");
			System.out.println(verMismatch);
			System.exit(1);
		}						
	
		if (args.length < 2 || args.length > 3) {
			System.out.println("Usage java -jar sb-wget.jar <URL> <dest-folder> [ -overwrite | -iterate ]");
			System.exit(1);
		}		
		
		WGet wget = new WGet();		
		
		URL url = wget.getClass().getResource(Context.myPackagePath + "WGet.class");
		if(url == null) {
			System.out.println(Context.myName + ": Cannot get the URL for the class: " + 
					Context.myPackagePath + "WGet.class");
			System.exit(1);
		}		
		
		String homeDir = url.getFile();
		if (homeDir.startsWith("file:"))
			homeDir = homeDir.substring(5);
		int idx = homeDir.indexOf('!');
		if (idx != -1)
			homeDir = homeDir.substring(0, idx);
		idx = homeDir.lastIndexOf('/');
		if (idx != -1)
			homeDir = homeDir.substring(0, idx);
		idx = homeDir.lastIndexOf('/');
		if (idx != -1) {
			if(homeDir.substring(idx + 1).toLowerCase().equals("lib"))
				homeDir = homeDir.substring(0, idx);
		}
		homeDir = homeDir.replaceAll("%20", " ");			
		
		Context.homeDir = homeDir + "/";
		System.out.println(Context.myName + ": Assuming " + Context.myName + " home dir is: " + homeDir);

		try {
			ClassPathHacker.addFile(Context.homeDir + "conf");
/*			
			File jmDir = new File(Context.homeDir + "lib/javamail/");
			if(jmDir.exists()) {
				File jars[] = jmDir.listFiles(new FilenameFilter() {
					public boolean accept(File dir, String name) {
						return (name.toLowerCase().indexOf(".jar") == name.length() - 4);
					}					
				});
				for(int i = 0; i < jars.length; i++) {
					ClassPathHacker.addFile(Context.homeDir + "lib/javamail/" + jars[i].getName());		
				}
			}
*/						
//			ClassPathHacker.addFile(Context.homeDir + "lib/" + "activation.jar");
/*			
			ClassPathHacker.addFile(Context.homeDir + "lib/" + "om-core.jar");
			ClassPathHacker.addFile(Context.homeDir + "lib/" + "commons-httpclient-2.0.jar");
			ClassPathHacker.addFile(Context.homeDir + "lib/" + "commons-logging-api.jar");
*/
			File jmDir = new File(Context.homeDir + "lib/");
			if (jmDir.exists()) {
				File jars[] = jmDir.listFiles(new FilenameFilter() {
					public boolean accept(File dir, String name) {
						return (name.toLowerCase().indexOf(".jar") == name
								.length() - 4)
								&& !name.equalsIgnoreCase("sb-wget.jar");
					}
				});
				for (int i = 0; i < jars.length; i++) {
					ClassPathHacker.addFile(Context.homeDir + "lib/"
							+ jars[i].getName());
				}
			}			
		} catch (Exception e) {
			e.printStackTrace();
		}	
			
		wget.go(args);
	}
		
	public void go(String[] args) {
		try {
			Context.loadSettings();
		} catch (java.util.MissingResourceException mre) {
			mre.printStackTrace();
			System.exit(1);
		} catch (Exception exc) {
			exc.printStackTrace();
		}
		File fld = new File(args[1]);
		if (fld.exists()) {
			if (!fld.isDirectory()) {
				System.out.println("Second argument should be a directory");
				System.exit(1);
			}
		} else {
			fld.mkdir();
		}
		int retCode = 0;
		int iterMode = Context.ITERATE_SKIP;
		if (args.length == 3) {
			if (args[2].equalsIgnoreCase("-overwrite"))
				iterMode = Context.ITERATE_OVERWRITE;
			else if (args[2].equalsIgnoreCase("-iterate"))
				iterMode = Context.ITERATE_YES;
		}

		try {
			WebContext.getCtnt(args[0], fld.getPath(), iterMode);
		} catch (Exception exc) {
			exc.printStackTrace();
			retCode = 2;
		}
		System.exit(retCode);
	}
	
}
